//---------------------------------------------------------------------------
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  1998-2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
//---------------------------------------------------------------------------
// stdmac.uc
// standard macros
//
//
// system: IXP1200


#include "ports_validcard.h"

#define BANK_SIZE_8MB
#define ALT_BANKS 1
#define DUAL_VALIDATE 1
#define RECEIVE16

#define PORT_MASK 0xf				; 16 slow ports
#define PORT_TO_TFIFO_MULT 1		; map of port number to TFIFO element
#define PORT_INCR 2					; increment between ports serviced by each FBOX

#define TOP_BUF_BYTE_OFFSET 0

// context assignments, ports and next threads
#ifdef UENGINE_ID	; UENGINE_ID must be defined for receive threads
	#if (UENGINE_ID == 0)
		#define PORT_NUMS 0,1,2,3
		#define NEXT_CTX0_TID 4
		#define NEXT_CTX1_TID 5
		#define NEXT_CTX2_TID 6
		#define NEXT_CTX3_TID 7
	#elif (UENGINE_ID == 1)
		#define PORT_NUMS 4,5,6,7
		#define NEXT_CTX0_TID 1
		#define NEXT_CTX1_TID 2
		#define NEXT_CTX2_TID 3
		#define NEXT_CTX3_TID 0
	#elif (UENGINE_ID == 2)
		#define PORT_NUMS 8,9,10,11
		#define NEXT_CTX0_TID 12
		#define NEXT_CTX1_TID 13
		#define NEXT_CTX2_TID 14
		#define NEXT_CTX3_TID 15
		#define VALIDATION_CARD 
	#elif (UENGINE_ID == 3)
		#define PORT_NUMS 12,13,14,15
		#define NEXT_CTX0_TID 9
		#define NEXT_CTX1_TID 10
		#define NEXT_CTX2_TID 11
		#define NEXT_CTX3_TID 8
		#define VALIDATION_CARD 
	#elif (UENGINE_ID == 4)
		#define FID 4
		#define EVEN
		#define VALIDATION_CARD 
	#elif (UENGINE_ID == 5)
		#define FID 5
		#define VALIDATION_CARD 
	#endif

	#define CORE_STACK_INTF1 18					// output interface for queueing to core


	// even receive microengines use freelist 0 and low sdram bank
	#if ((UENGINE_ID & 1) == 0)
		#define FREELIST_ID 0
		#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
	#else
		#ifdef ALT_BANKS
	// odd receive microengines use freelist 1 and high sdram bank
			#define FREELIST_ID 1
			#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_HIGH_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
		#else
			#define FREELIST_ID 0
			#define FREELIST_HANDLE FREELIST_ID, SDRAM_PKT_BUFFER_BASE, PKBUF_SIZE, SRAM_BUFF_DESCRIPTOR_BASE, DESC_SIZE
		#endif
	#endif


	// define Q handles for the slow port queues
	#define Q_HANDLE Q_LINKED_LIST_8, XMIT_PWP_VECTOR, SRAM_QUEUE_DESCRIPTOR_BASE, SRAM_BUFF_DESCRIPTOR_BASE


#endif UENGINE_ID



